fs = 48e3;
taps = 99;
f_norm = [zeros(1,100) ones(1,100) zeros(1,300)];                                   %周波数特性を定義
%f_norm = [ones(1,50)*0.1 ones(1,50)*0.01, ones(1,50) ones(1,50)*0.5 zeros(1,300)]; 
f_norm = [f_norm fliplr(f_norm(2:end))];                                            %鏡像の付加
ifft_out = real(ifft(f_norm));                                                      %IFFT
ifft_shift = fftshift(ifft_out);                                                    %切り出したい位置を中心に移動
center = ceil(length(f_norm)/2);
impulse_rect = ifft_shift((center-floor(taps/2):(center+floor(taps/2))))            %インパルス応答の切り出し
w = hamming(taps)';                                                                 %窓関数
impulse_hamming = impulse_rect.*w;                                                  %窓関数を適用
stem(impulse_hamming);                                                              %以下グラフ表示操作
fft_n = 1000;
f = (0:1:(fft_n-1))/fft_n * fs;
fft_out = fft( impulse_hamming, 1000 );
mag = abs(fft_out);
phase = unwrap(angle(fft_out));
figure;
plot( f,20*log10( mag ) );
xlabel("Frequency[Hz]");
ylabel("Magnitude[dB]");
xlim([0 fs/2]);
ylim([-100 10]);
figure;
plot( f,phase );
xlabel("Frequency[Hz]");
ylabel("Phase[rad]");
xlim([0 fs/2]);

[audio, fs_audio] = audioread("VSQSE_965_cat_6.wav");                               %以下音声出力
audio = audio(:,1);                                          
audio = resample(audio, fs, fs_audio);                    
filter_out = filter(impulse_hamming, 1, audio); 
soundsc(filter_out, fs_impulse, 16)                                  
audiowrite("cat_bpf.wav",filter_out, fs_impulse);